/* **********************************************************
 * Copyright (C) 1998-2000 VMware, Inc.
 * All Rights Reserved
 * **********************************************************/

#ifndef __VMNETINT_H__
#define __VMNETINT_H__


#define INCLUDE_ALLOW_MODULE
#include "includeCheck.h"
#include "driver-config.h"


/*
 * Hide all kernel compatibility stuff in those macros
 */


#ifdef KERNEL_2_1
#   define compat_fop_set_poll(_pFop, _pFunc) do { \
   (_pFop)->poll = (_pFunc);                       \
} while (0)
#else
#   define compat_fop_set_poll(_pFop, _pFunc) do { \
   (_pFop)->select = (_pFunc);                     \
} while (0)
#endif


#ifdef KERNEL_2_4_0
#   define compat_fop_set_owner(_pFop) do { \
   (_pFop)->owner = THIS_MODULE;            \
} while (0)
#   define compat_mod_inc_refcount
#   define compat_mod_dec_refcount
#else
#   define compat_fop_set_owner(_pFop)
#   define compat_mod_inc_refcount do { \
   MOD_INC_USE_COUNT;                   \
} while (0)
#   define compat_mod_dec_refcount do { \
   MOD_DEC_USE_COUNT;                   \
} while (0)
#endif


#ifndef KERNEL_2_1
#   define net_device_stats enet_statistics
#endif


#ifndef KERNEL_2_5_2
#   define major(_dev) MAJOR(_dev)
#   define minor(_dev) MINOR(_dev)
#endif


#if defined(KERNEL_2_5_5)
#   define compat_sk_alloc(_pri) sk_alloc(0, _pri, 1, NULL)
#elif defined(KERNEL_2_1)
#   define compat_sk_alloc(_pri) sk_alloc(0, _pri, 1)
#else
#   define compat_sk_alloc(_pri) sk_alloc(_pri)
#endif


#ifndef KERNEL_2_4_8
#   define netif_rx_ni(_skb) netif_rx(_skb)
#endif


#endif /* __VMNETINT_H__ */
